unit DrawCommandClickCustInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ppDB, ppDBPipe, Db, DBTables, ppPrnabl, ppClass, ppCtrls,
  ppBands, ppCache, ppComm, ppRelatv, ppProd, ppReport, ppParameter;

type
  TForm3 = class(TForm)
    ppReport1: TppReport;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    ppDBText1: TppDBText;
    dsCustomer: TDataSource;
    tblCustomer: TTable;
    plCustomer: TppDBPipeline;
    Button1: TButton;
    Memo1: TMemo;
    procedure ppDBText1DrawCommandCreate(Sender, aDrawCommand: TObject);
    procedure ppDBText1DrawCommandClick(Sender, aDrawCommand: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


  {TmyCustInfo
    This class is used to store customer information for each draw command}
  TmyCustInfo = class(TComponent)
    private
      FCustNo: Integer;
      FCountry: String;
    public
      constructor CreateCustInfo(aOwner: TComponent; aCustNo: Integer; aCountry: String); virtual;

      property CustNo: Integer read FCustNo;
      property Country: String read FCountry;
    end;


var
  Form3: TForm3;

implementation

{$R *.DFM}

constructor TmyCustInfo.CreateCustInfo(aOwner: TComponent; aCustNo: Integer; aCountry: String);
begin
  inherited Create(aOwner);

  FCustNo  := aCustNo;
  FCountry := aCountry;

end;

procedure TForm3.Button1Click(Sender: TObject);
begin
  ppReport1.Print;
end;


procedure TForm3.ppDBText1DrawCommandCreate(Sender, aDrawCommand: TObject);
var
  lCustInfo: TmyCustInfo;
begin
  {create customer info}
  lCustInfo := TmyCustInfo.CreateCustInfo(Self, plCustomer['CustNo'], plCustomer['Country']);

  {attach to draw command}
  TComponent(aDrawCommand).Tag := Integer(lCustInfo);

end;

procedure TForm3.ppDBText1DrawCommandClick(Sender, aDrawCommand: TObject);
var
  lCustInfo: TmyCustInfo;
  lsCustNo: String;
begin
  {get customer info}
  lCustInfo := TmyCustInfo(TComponent(aDrawCommand).Tag);

  lsCustNo := IntToStr(lCustInfo.CustNo);

  ShowMessage('CustNo: ' + lsCustNo + #13#10 +
              'Country: ' + lCustInfo.Country) ;

end;


end.
